// https://flowbite.com/docs/components/timeline/
// TODO : Timeline
// Timeline with icons
// Horizontal timeline
// activity timeline (custom)

use maud::{PreEscaped, html};

use crate::ui::UIWidget;

pub struct TimelineElement {
    icon: Option<Box<dyn UIWidget>>,
    title: Box<dyn UIWidget>,
    time: String,
    body: Box<dyn UIWidget>,
}

pub struct TimelineWidget {
    horizontal: bool,
    elements: Vec<TimelineElement>,
}

pub fn Timeline() -> PreEscaped<String> {
    html! {
            ol class="relative border-s border-gray-200 dark:border-gray-700" {

                li class="mb-10 ms-6" {
                span class="absolute flex items-center justify-center w-6 h-6 bg-blue-100 rounded-full -start-3 dark:ring-gray-900 dark:bg-blue-900" {
                    svg class="w-2.5 h-2.5 text-blue-800 dark:text-blue-300" aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="currentColor" viewBox="0 0 20 20" {
                        path d="M20 4a2 2 0 0 0-2-2h-2V1a1 1 0 0 0-2 0v1h-3V1a1 1 0 0 0-2 0v1H6V1a1 1 0 0 0-2 0v1H2a2 2 0 0 0-2 2v2h20V4ZM0 18a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2V8H0v10Zm5-8h10a1 1 0 0 1 0 2H5a1 1 0 0 1 0-2Z" {};
                    };
                };
                h3 class="mb-1 text-lg font-semibold text-gray-900 dark:text-white" { "Flowbite Figma v1.3.0" };
                time class="block mb-2 text-sm font-normal leading-none text-gray-400 dark:text-gray-500" { "Released on December 7th, 2021" };
                p class="text-base font-normal text-gray-500 dark:text-gray-400" { "All of the pages and components are first designed in Figma and we keep a parity between the two versions even as we update the project." };
                };

    li class="mb-10 ms-4" {
        div class="absolute w-3 h-3 bg-gray-200 rounded-full mt-1.5 -start-1.5 border border-white dark:border-gray-900 dark:bg-gray-700" {};
        time class="mb-1 text-sm font-normal leading-none text-gray-400 dark:text-gray-500" { "March 2022" };
        h3 class="text-lg font-semibold text-gray-900 dark:text-white" { "Marketing UI design in Figma" };
        p class="text-base font-normal text-gray-500 dark:text-gray-400" { "All of the pages and components are first designed in Figma and we keep a parity between the two versions even as we update the project." };
    };

    li class="ms-4" {
        div class="absolute w-3 h-3 bg-gray-200 rounded-full mt-1.5 -start-1.5 border border-white dark:border-gray-900 dark:bg-gray-700" {};
        time class="mb-1 text-sm font-normal leading-none text-gray-400 dark:text-gray-500" { "April 2022" };
        h3 class="text-lg font-semibold text-gray-900 dark:text-white" { "E-Commerce UI code in Tailwind CSS" };
        p class="text-base font-normal text-gray-500 dark:text-gray-400" { "Get started with dozens of web components and interactive elements built on top of Tailwind CSS." };
    };

            };
        }
}

// TODO : https://flowbite.com/docs/components/timeline/#activity-log
